﻿using ThinkGeo.MapSuite.Core;

namespace displaymap
{
    public struct FeatureInfo
    {
        private Feature feature;
        private ShapeFileFeatureLayer shape;

        public Feature Feature
        {
            get { return feature; }
            set { feature = value; }
        }

        public ShapeFileFeatureLayer ShapeFile
        {
            get { return shape; }
            set { shape = value; }
        }

        public override bool Equals(object obj)
        {
            if (obj == null)
            {
                return false;
            }

            if (obj is FeatureInfo)
            {
                return Equals((FeatureInfo)obj);
            }

            return false;
        }

        public override int GetHashCode()
        {
            return feature.GetHashCode() ^ shape.GetHashCode();
        }

        public static bool operator ==(FeatureInfo featureInfo1, FeatureInfo featureInfo2)
        {
            return featureInfo1.Equals(featureInfo2);
        }

        public static bool operator !=(FeatureInfo featureInfo1, FeatureInfo featureInfo2)
        {
            return !(featureInfo1 == featureInfo2);
        }

        private bool Equals(FeatureInfo featureInfo)
        {
            if (this.feature != featureInfo.feature) { return false; }
            if (this.shape != featureInfo.shape) { return false; }

            return true;
        }
    }
}
